import express,{Router, Request, Response} from 'express';
import {Project} from '../models/Project';
import {myDataSource} from '../app-data-source';

const router:Router = express.Router();
const dataSource = myDataSource;


router.get('/',async (req:Request, res:Response) => {
    const projects:Project[]|undefined = await dataSource.manager.find(Project)
    return res.send({projects})
})

router.get("/:project_id",async (req:Request, res:Response) => {
    const project : Project|null= await dataSource.manager.findOneBy(Project, {
        id: req.params.project_id
    })
    if (!project) return res.status(404).send({Message:'no info in the base'})
    return res.send({project})
})

export default router;
