import express, { Express } from 'express';
import cors from 'cors';
import users from './routers/users';
import {myDataSource} from './app-data-source';


myDataSource
.initialize()
.then(() => {
    console.log("Data Source has been initialized!")
})
.catch((err) => {
    console.error("Error during Data Source initialization:", err)
})

const app:Express = express();
app.use(express.static('public'));
app.use(cors())
app.use(express.json());
const PORT = 8000;
app.use('/users',users)

const run = async() => {
    
    
    app.listen(PORT, () => {
        console.log(`Server started at http://localhost:${PORT}/`);
    })

}

console.log('Hello world!');
run().catch(console.error);